#
# This Mod was created by Defiant <mail@defiant.homedns.org>
# and is under the GNU GPL License (watch README)!
# 
# Basic TractorTargetDocked() and TractorBeamOn() are from the SDK and
# some parts of GetShuttlesInBay(), IncreaseShuttleCount() and ShuttlesInBayOfThisType()
# are copied from sleight42 Shuttle Launching Framework.
#
# Have Fun!

import App
import MissionLib

pGame = App.Game_GetCurrentGame()
pEpisode = pGame.GetCurrentEpisode()
pMission = pEpisode.GetCurrentMission()

g_pMissionDatabase 	= None
g_pFelix		= None
g_pBrex			= None


# Here we Count the Shuttles in our Bay
# Basicly copied from the Shuttle Launching Framework by sleight42 (AddLaunchButtons() in LaunchShipHandlers.py)
def GetShuttlesInBay():
	import ftb.ShipManager
	
	pCarrier = ftb.ShipManager.GetShip( MissionLib.GetPlayer())
	pLaunchers = pCarrier.GetLaunchers()
	numTypes = len( pLaunchers)
	for index in range( numTypes):
		launchType = pLaunchers[index].GetLaunchType()
		numLaunches =  pLaunchers[index].GetNumLaunches( launchType)
		firstlaunchType = launchType
		
		launchType = None
		
		i = 0
		while (launchType != firstlaunchType):
			launchType = pLaunchers[index].NextLaunchType()
			if (launchType != firstlaunchType):
				numLaunches =  numLaunches + pLaunchers[index].GetNumLaunches( launchType)
			
			if ( i > 10 ):
			# This makes sure the Game is not crashing if we have 0 Shuttles in Bay.
				return 0
			i = i + 1
			
	return numLaunches


#How much Shuttles can we get in our Bay?
def GetMaxShuttlesInBay(OurShipName):
	# Carrier Plugin to be used
	import Custom.Carriers.MaxShuttlesInBay
	MaxShuttlesInBay = Custom.Carriers.MaxShuttlesInBay.SetMaxShuttlesInBay(OurShipName)
	return MaxShuttlesInBay


def IncreaseShuttleCount(Shuttle):
	#print("Trying to increase Shuttle Count")

	import string
	ShipString = string.split(Shuttle, ' ')
	#print(ShipString[:1])
	if ( string.find(str(ShipString[:1]), '-') != "-1" ):
		#print("- still found")
		ShipString = string.split(Shuttle, '-')
		#print(ShipString[:1])
		
	# damm...this looks to much like logo for me...
	ShipType = string.replace(string.replace(str(ShipString[:1]), '\']', ''), '[\'', '')
	# ^^Dont ask me, what this doing, I forget it 2 hours after writing...it just...works
	ShipType = string.replace(ShipType, ' ', '')
	# And now we deal with the last spaces
	#print(ShipType)


	ShipCount = ShuttlesInBayOfThisType(ShipType)
	#print("Ship Counts:")
	#print(ShipCount)
	
	ShuttleCountCorrection = 0
	if ( ShipCount > 0 ):
		#print("Correction needed")
		ShuttleCountCorrection = 1

	pShip = App.Game_GetCurrentPlayer()

	# TODO: If we started all Shuttles the Carrier System sucks up...trying to fix...
	# Not working yet
	#if ( ShipCount == 0 ):
	#	print("Trying to get Carrier System working again")
	#	import ftb.LaunchShipHandlers
	#	global pLaunchButton
	#	pLaunchButton = ftb.LaunchShipHandlers.pLaunchButton
	#	pLaunchButton[1].SetEnabled()
	#
	#	import ftb.LaunchShipHandlers
	#	#App.g_kEventManager.AddBroadcastPythonFuncHandler(App.ET_MISSION_START, App.Game_GetCurrentGame(), __name__ + "LaunchShipHandlers.MissionStart")
	#	ftb.LaunchShipHandlers.MissionStart(App.ET_MISSION_START, App.Game_GetCurrentGame())
	
	
	# Thats from the Carrier System config by Sleight42
	LauncherManager = __import__( "ftb.LauncherManager")
	launcher = LauncherManager.GetLauncher( "Shuttle Bay", pShip)
	launcher.AddLaunchable( ShipType, "QuickBattle.QuickBattleFriendlyAI", 1)
	
	if ( ShuttleCountCorrection == 1 ):
		# We have to do this, cause sometimes launcher.AddLaunchable only overwrite the count.
		ShipCountCorrection = ShuttlesInBayOfThisType(ShipType)
		#print(ShipCountCorrection)
		if ( ShipCountCorrection == 1 ):
			#print ("Doing correction")
			# again from the Carrier System config by Sleight42
			launcher.AddLaunchable( ShipType, "QuickBattle.QuickBattleFriendlyAI", ShipCount + 1)
	
	#print(ShipCount)
		

def GetShuttleBaySize(OurShipName, pEvent, pShip):
	iShipID = pShip.GetObjID()
	pProperty = MissionLib.FindShuttleBay(iShipID)

	if (pProperty == None):
		print("No Shuttle Bay found")
		return
	#print("Got the Shuttle Bay")
	
	pObject = App.ShipClass_GetObjectByID(App.SetClass_GetNull(), iShipID)
	#hmm...we get a Value here, but what Value? -it is not realy the Radius of the Shuttle Bay!
	ShuttleBaySize = pObject.GetRadius()

	return ShuttleBaySize


# This make sure we don't destroy the other Shuttles in this Bay
# Its mostly the same like GetShuttlesInBay(), so also from the Shuttle Launching Framework by sleight42.
def ShuttlesInBayOfThisType(Type):
	import ftb.ShipManager
	
	pCarrier = ftb.ShipManager.GetShip( MissionLib.GetPlayer())
	pLaunchers = pCarrier.GetLaunchers()
	numTypes = len( pLaunchers)
	for index in range( numTypes):
		launchType = None
				
		i = 0
		while (launchType != Type):
			#print(Type)
			#print(launchType)
			launchType = pLaunchers[index].NextLaunchType()
			numLaunches =  pLaunchers[index].GetNumLaunches( launchType)
			if ( i > 10 ):
			# Stop crashing Stupid Game
				return 0
			i = i + 1
	
	return numLaunches
	

################################################################################
##	TractorTargetDocked()
##
##	Event handler called when tractor target has docked with ship.
##
##	Args:	pTGObject	- The TGObject object
##			pEvent		- The event that was sent to the object
##
##	Return:	None
################################################################################
def TractorTargetDocked(pTGObject, pEvent):
	#print("Calling TractorTargetDocked()")

	# Get some Var for the Audio Lines
	global g_pMissionDatabase
	global g_pFelix
	
	pBridge = App.g_kSetManager.GetSet("bridge")
	g_pMissionDatabase 	= pMission.SetDatabase("data/TGL/QuickBattle/ReturnShuttles.tgl")
	g_pFelix	= App.CharacterClass_GetObject(pBridge, "Tactical")

	# Get the object that was docked and it's name
	pObject	= App.ShipClass_Cast(pEvent.GetObjPtr())
	if (pObject == None):
		return
	pShip	= App.ShipClass_Cast(pEvent.GetDestination())
	if (pShip == None):
		return
	sShipName	= pShip.GetName()
	sName 	= pObject.GetName()

	# Remove the Object from the set
	pObject.SetDeleteMe(1)
	
	if (sName[:3] == "Ret"):
		if (sShipName == "Player"):
			#print("Play the audio line that will let the player know pod is docked")
			pSequence = App.TGSequence_Create()
			pFelixLine	= App.CharacterAction_Create(g_pFelix, App.CharacterAction.AT_SAY_LINE, "E6M2PodDocked", "Captain", 1, g_pMissionDatabase)
			pSequence.AppendAction(pFelixLine, 2) #2 second delay
			pSequence.Play()
	else:
	# and increase the captured count
		IncreaseShuttleCount(sName)

	#print("Tractor Target Docked is finished and done")

################################################################################
##	TractorBeamOn()
##
##	Event handler called when tractor beam starts hitting a target.  Checks to
##	see if the target is a pod and starts docking behavior if it is.
##
##	Args:	TGObject	- The TGObject object.
##			pEvent		- The event that was sent.
##
##	Return:	None
################################################################################
def TractorBeamOn(TGObject, pEvent):
	# Get the event destination (the thing hit by tractor beam)
	#print("Tractor Beam on")

	# Get some Var for the Audio Lines
	global g_pMissionDatabase
	global g_pFelix
	global g_pBrex
	pBridge 		= App.g_kSetManager.GetSet("bridge")
	g_pMissionDatabase 	= pMission.SetDatabase("data/TGL/QuickBattle/ReturnShuttles.tgl")
	g_pFelix		= App.CharacterClass_GetObject(pBridge, "Tactical")
	g_pBrex			= App.CharacterClass_GetObject(pBridge, "Engineer")
	ShuttleBaySize		= None
	MaxShuttlesInBay	= None
	
	pShip = App.ShipClass_Cast(pEvent.GetDestination())
	if (pShip == None):
		print("failed - no Ship")
		return
		
	sTargetName = pShip.GetName()
	#print("Target Ship in Tractor is: " + sTargetName)
	
	#Lets try to get the size of our Target ship
	TargetHullSize = pShip.GetHull().GetRadius() * 8 # 8 is a Size correction
	#print("Size of the Target:")
	#print(TargetHullSize)

	# Get the tractor beam system that fired so we
	# can set it's behavior.
	pTractorProjector	= App.TractorBeamProjector_Cast(pEvent.GetSource())
	pTractorSystem		= App.TractorBeamSystem_Cast(pTractorProjector.GetParentSubsystem())
	
	# Get the name of the ship that fired
	pShip = pTractorSystem.GetParentShip()
	if (pShip == None):
		return
	sFiringShipName = pShip.GetName()
	
	OurShipName = pShip.GetShipProperty().GetShipName()
	#print("Firing Ship Name: " + OurShipName)	

	#and the size of our Shuttle Bay
	ShuttleBaySize=GetShuttleBaySize(OurShipName, pEvent, pShip)
	#print("Size of our Shuttle Bay:");
	if (ShuttleBaySize == None):
		print("ShuttleBaySize not set")
		return
	#print(ShuttleBaySize)
	
	#print("Max Shuttles we can carry:");
	MaxShuttlesInBay=GetMaxShuttlesInBay(OurShipName)
	if (MaxShuttlesInBay == None):
		MaxShuttlesInBay = 10
		#print("None set")
	#print(MaxShuttlesInBay)
	
	ShuttlesInBay=GetShuttlesInBay()
	#print("Shuttles currently in Bay:")
	#print(ShuttlesInBay)

	# See if the ship is small enough to fit into out Bay
	if (TargetHullSize < ShuttleBaySize):
		#print("Target is small enough to get in our Bay")

		if (sTargetName[:10] == "Escape Pod"):
			# It's a pod
			#print("Playing Brex's .attempting to dock pod. line")	
			pBrexLine = App.CharacterAction_Create(g_pBrex, App.CharacterAction.AT_SAY_LINE, "E6M2FelixDockPod", "Captain", 1, g_pMissionDatabase)
			pBrexLine.Play()
			
			# set the tractor beam to pull in and dock the pod
			pTractorSystem.SetMode(pTractorSystem.TBS_DOCK_STAGE_1)
		elif (sTargetName[:14] == "Rettungskapsel"):
			# It's a pod - thats for the german people.
			#print("Playing Brex's .attempting to dock pod. line")	
			pBrexLine = App.CharacterAction_Create(g_pBrex, App.CharacterAction.AT_SAY_LINE, "E6M2FelixDockPod", "Captain", 1, g_pMissionDatabase)
			pBrexLine.Play()
			
			# set the tractor beam to pull in and dock the pod
			pTractorSystem.SetMode(pTractorSystem.TBS_DOCK_STAGE_1)
		else:
			# It's not a Pod
			# Test if we got enough space in our Bay left
			if ( MaxShuttlesInBay > ShuttlesInBay ):
				#print("There is enough space left in our Bay")
				#print("Target will be docked")
				
				#print("Playing Brex's attempting to dock line")	
				pBrexLine = App.CharacterAction_Create(g_pBrex, App.CharacterAction.AT_SAY_LINE, "FelixDockShip", "Captain", 1, g_pMissionDatabase)
				pBrexLine.Play()

				# set the tractor beam to pull in and dock the pod
				pTractorSystem.SetMode(pTractorSystem.TBS_DOCK_STAGE_1)
			else:
				print("Sorry: No Space left")
				return

	# We're done.  Let any other handlers for this event handle it.
	#print("Tractor beam on finished")
	TGObject.CallNextHandler(pEvent)
	


#print("Loading Defiants event Handlers to get the Shuttles back")

# Tractor beam target docked event
App.g_kEventManager.AddBroadcastPythonFuncHandler(App.ET_TRACTOR_TARGET_DOCKED, pMission, __name__+".TractorTargetDocked")
# Tractor beam starts hitting event
App.g_kEventManager.AddBroadcastPythonFuncHandler(App.ET_TRACTOR_BEAM_STARTED_HITTING, pMission, __name__+".TractorBeamOn")
